From 3bd918d92f8c34ba12de9c6604d96f9e262a59fc Mon Sep 17 00:00:00 2001
From: Martin Matuska <martin@matuska.de>
Date: Tue, 12 Sep 2023 08:54:47 +0200
Subject: [PATCH] tests: fix zstd long option test for 32-bit architectures

Fixes #1968
---
 libarchive/test/test_write_filter_zstd.c | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

diff --git a/libarchive/test/test_write_filter_zstd.c b/libarchive/test/test_write_filter_zstd.c
index 3cdbd812..c9731f1b 100644
--- a/libarchive/test/test_write_filter_zstd.c
+++ b/libarchive/test/test_write_filter_zstd.c
@@ -161,8 +161,12 @@ DEFINE_TEST(test_write_filter_zstd)
 	    archive_write_set_filter_option(a, NULL, "max-frame-size", "1048576"));
 #endif
 #if ZSTD_VERSION_NUMBER >= MINVER_LONG
-	assertEqualIntA(a, ARCHIVE_OK,
-	    archive_write_set_filter_option(a, NULL, "long", "27"));
+	if ((int)(sizeof(size_t) == 4))
+		assertEqualIntA(a, ARCHIVE_OK,
+		    archive_write_set_filter_option(a, NULL, "long", "26"));
+	else
+		assertEqualIntA(a, ARCHIVE_OK,
+		    archive_write_set_filter_option(a, NULL, "long", "27"));
 	assertEqualIntA(a, ARCHIVE_FAILED,
 	    archive_write_set_filter_option(a, NULL, "long", "-1")); /* negative */
 #endif
-- 
2.41.0

